#!/usr/bin/env python
# -*- coding:utf-8 -*-

# ##############################################################################
#     Base code from where the autogenerated code inherits
#
#     Copyright (C) 2021 Alba Synchrotron/CELLS, Cerdanyola Spain
#
#     This program is free software: you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation, either version 3 of the License, or
#     (at your option) any later version.
#
#     This program is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
#
#     You should have received a copy of the GNU General Public License
#     along with this program.  If not, see [http://www.gnu.org/licenses/].
# ##############################################################################

from numpy import array, append


class ProcessStatistics:
    _time_arrays_max_length = None
    _internal_procedure_times = None
    _read_registers_time = None
    _process_registers_time = None
    _internal_formulas_time = None
    _events_emitted = None

    def __init__(self, time_arrays_max_length=100):
        self._time_arrays_max_length = time_arrays_max_length
        self._internal_procedure_times = array([])
        self._read_registers_time = array([])
        self._process_registers_time = array([])
        self._internal_formulas_time = array([])
        self._events_emitted = array([], dtype=int)

    @property
    def time_arrays_max_length(self):
        return self._time_arrays_max_length

    @time_arrays_max_length.setter
    def time_arrays_max_length(self, value):
        if value <= 0:
            raise ValueError("time_arrays_max_length must be strictly positive")
        elif value > 1000:
            raise ValueError("time_arrays_max_length must be smaller than 1000")
        self._time_arrays_max_length = int(value)

    @property
    def internal_procedure_times(self):
        return self._internal_procedure_times

    @internal_procedure_times.setter
    def internal_procedure_times(self, value):
        self._internal_procedure_times = self.__append_to_array(
            self._internal_procedure_times, value)

    @property
    def read_registers_time(self):
        return self._read_registers_time

    @read_registers_time.setter
    def read_registers_time(self, value):
        self._read_registers_time = self.__append_to_array(
            self._read_registers_time, value)

    @property
    def process_registers_time(self):
        return self._process_registers_time

    @process_registers_time.setter
    def process_registers_time(self, value):
        self._process_registers_time = self.__append_to_array(
            self._process_registers_time, value)

    @property
    def internal_formulas_time(self):
        return self._internal_formulas_time

    @internal_formulas_time.setter
    def internal_formulas_time(self, value):
        self._internal_formulas_time = self.__append_to_array(
            self._internal_formulas_time, value)

    @property
    def events_emitted(self):
        return self._events_emitted

    @events_emitted.setter
    def events_emitted(self, value):
        self._events_emitted = self.__append_to_array(
            self._events_emitted, value)

    def __append_to_array(self, arr, value):
        """
Given a numpy array append a value to it and check if the number of elements
in the array has to be cut to behave like a circular buffer

:param arr: numpy array
:param value: value of the type that the array is
:return: the array with the value inserted with the length below or equal
         to the configured size.
        """
        arr = append(arr, value)
        if len(arr) >= self._time_arrays_max_length:
            arr = arr[-self._time_arrays_max_length:]
        return arr
